package	jp.co.sds_corp.ratemixer.fx.source;

import java.io.OutputStream;
import java.math.BigDecimal;
import java.util.List;

import jp.co.sds_corp.ratemixer.fx.FxRate;
import jp.co.sds_corp.transfer.StatusChangeEvent;
import jp.co.sds_corp.util.common.JsonData;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

/**
* JSONから、HTTP経由で為替レートを取得します。
*/
public class Json extends HttpSource
{
	static final CmnLogger logger = CmnLogFactory.getLogger();
	String term = "SP";

	public void init( IConfiguration config ) throws Exception {
		super.init( config );
	}

	public void analyze( String res ) throws Exception {
		FxRate	tmp;
		JsonData dataAll = JsonData.parse( res );
		List list = dataAll.getList( "quotes" );
		for ( int i = 0; i < list.size(); i++ ) {
			JsonData data = (JsonData )list.get( i );
			if ( isDebug()) {
				logger.debug( this, "received." + data );
			}
			String key = data.getValue( "currencyPairCode" ) + term;
			FxRate rate = (FxRate )getRateMap().get( key );
			if ( rate == null ) {
				if ( isDebug()) {
					logger.debug( this, "rate not found.[" + key + "]" );
				}
				continue;
			}
			BigDecimal bid, ask;
			try {
				bid = new BigDecimal( data.getValue( "bid" ));
				ask = new BigDecimal( data.getValue( "ask" ));
			} catch ( Exception ex ) {
				continue;
			}
			tmp = new FxRate( (FxRate )rate );
			tmp.setBid( bid );
			tmp.setAsk( ask );

			if ( !rate.isInit() ) {
			} else {
				fireStatusChange( new StatusChangeEvent( this,
									StatusChangeEvent.STAT_INIT,
									StatusChangeEvent.STAT_RUN,
									"start" ));
				tmp.setInit( false );
			}
			getRateMap().put( key, tmp );
			if ( !rate.equals( tmp ) ) {
				bChg = true;
				fireReceive( tmp );
			}
		}
	}

	public void sendRequest( OutputStream os ) {
	}

}
